/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   assignment.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_ASSIGNMENT_H
#define UHDM_ASSIGNMENT_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class assignment : public atomic_stmt {
  public:
    // Implicit constructor used to initialize all members,
    // comment: assignment();
    ~assignment() final {}
    
    const BaseClass* VpiParent() const final { return vpiParent_; }

    bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    unsigned int UhdmParentType() const final { return uhdmParentType_; }

    bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    const std::string& VpiFile() const final;

    bool VpiFile(const std::string& data) final;

    unsigned int VpiLineNo() const final { return vpiLineNo_; }

    bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    int VpiOpType() const { return vpiOpType_; }

    bool VpiOpType(int data) { vpiOpType_ = data; return true;}

    bool VpiBlocking() const { return vpiBlocking_; }

    bool VpiBlocking(bool data) { vpiBlocking_ = data; return true;}

    const expr* Lhs() const { return lhs_; }

    bool Lhs(expr* data) { lhs_ = data; return true;}

    const delay_control* Delay_control() const { return delay_control_; }

    bool Delay_control(delay_control* data) { delay_control_ = data; return true;}

    const event_control* Event_control() const { return event_control_; }

    bool Event_control(event_control* data) { event_control_ = data; return true;}

    const repeat_control* Repeat_control() const { return repeat_control_; }

    bool Repeat_control(repeat_control* data) { repeat_control_ = data; return true;}

    const any* Rhs() const { return rhs_; }

    bool Rhs(any* data) {if (!expr_interf_expr_groupGroupCompliant(data)) return false; rhs_ = data; return true;}

    unsigned int VpiType() { return vpiAssignment; }

    UHDM_OBJECT_TYPE UhdmType() const final { return uhdmassignment; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    int vpiOpType_;

    bool vpiBlocking_;

    expr* lhs_;

    delay_control* delay_control_;

    event_control* event_control_;

    repeat_control* repeat_control_;

    any* rhs_;

  };

  
  class assignmentFactory {
  friend Serializer;
  public:
  assignment* Make() {
    assignment* obj = new assignment();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<assignment*> objects_;
  };
  
  
  class VectorOfassignmentFactory {
  friend Serializer;
  public:
  std::vector<assignment*>* Make() {
    std::vector<assignment*>* obj = new std::vector<assignment*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<assignment*>*> objects_;
  };

};

#endif

